package fel.kte.pkropik.it;

import java.util.ArrayList;
import java.util.InputMismatchException;
import java.util.Scanner;

public class Prvni {

    public static void main(String[] args) {
        Scanner klavesnice = new Scanner(System.in);

        int kolikNovychZvirat;
        while (true) {
            System.out.format("Kolik nových zvířat bude: ");
            try {
                kolikNovychZvirat = klavesnice.nextInt();
                if (kolikNovychZvirat >= 0) {
                    klavesnice.nextLine();
                    break;
                }
            } catch (InputMismatchException ex) {
                System.out.format("Je nutno zadat celé kladné číslo.%n");
                klavesnice.nextLine();
            }
        } // konec cyklu while
        System.out.format("Budeme přidávat %d zvířat.%n", kolikNovychZvirat);

        // assert kolikNovychZvirat != 0 : "Promenna nesmi byt nulova"; // pro účely testovacího režimu

        if (kolikNovychZvirat == 0) {
            System.out.format("Tak nic, no. Adieu...");
            return;
        }

        ArrayList<Zvire> seznamZOO = new ArrayList<>(kolikNovychZvirat);

        for (int i = 0; i < kolikNovychZvirat; i++) {
            System.out.format("Jméno %d. zvířete: ", i+1);
            String jmeno = klavesnice.nextLine();
            int vyska;
            int dobaBrezosti;
            while (true) {
                try {
                    System.out.format("Zadejte výšku zvířete: ");
                    vyska = klavesnice.nextInt();
                    klavesnice.nextLine();

                    System.out.format("Zadejte dobu březosti savce: ");
                    dobaBrezosti = klavesnice.nextInt();
                    klavesnice.nextLine();

                    seznamZOO.add(new Savec(vyska, jmeno, dobaBrezosti));
                    break;
                } catch (InputMismatchException | ZapornaHodnotaVyjimka ex) {
                    System.out.format("Je nutno zadat celé kladné číslo.%n");
                    klavesnice.nextLine();
                }
            } // konec cyklu while
        }

        seznamZOO.add(new Zvire());
        seznamZOO.add(new Savec());

        System.out.format("Máme v ZOO celkem %d zvířat%n", seznamZOO.size());

        for (Zvire mazlik : seznamZOO) {
            // System.out.format("%d. Jméno: %s, výška: %d%n", seznamZOO.indexOf(mazlik) + 1, mazlik.getJmeno(), mazlik.getVyska());
            System.out.format("Informace z toString: %s%n", mazlik);
        }

        // seznamZOO.clear();

        /*
        System.gc();
        System.runFinalization();
        */

        try {
            seznamZOO.remove(seznamZOO.get(1));
            //seznamZOO.remove(1);
        }
        catch (IndexOutOfBoundsException ex) {
            System.out.format("Index je mimo rozsah seznamu...%n");
        }


        for (int i = 0; i < seznamZOO.size(); i++) {
            // System.out.format("%d. Jméno: %s, výška: %d%n", i+1, seznamZOO.get(i).getJmeno(), seznamZOO.get(i).getVyska());
            System.out.format("Informace z toString: %s%n", seznamZOO.get(i));
        }
    }
}
