package fel.kte.pkropik.it;

public class Zvire {
    // zatím bez zapouzdření (tj. bez private)
    private int vyska = 0;
    private String jmeno = "Ještě nemá";

    public Zvire() {
        // zajišťuje defaultní inicializaci - viz výše
    }

    /**
     * Konstruktor třídy Zvire
     * @param vyska výška zířete v cm
     * @param jmeno jméno mazlíka
     * @throws ZapornaHodnotaVyjimka
     */
    public Zvire(int vyska, String jmeno) throws ZapornaHodnotaVyjimka {
        setJmeno(jmeno);
        setVyska(vyska);
    }

    public int getVyska() {
        return vyska;
    }

    public final void setVyska(int vyska) throws ZapornaHodnotaVyjimka {
        if (vyska < 0) {
            throw new ZapornaHodnotaVyjimka("Pokus o nastavení hodnoty: " + vyska);
        }
        else {
            this.vyska = vyska;
        }
    }

    public String getJmeno() {
        return jmeno;
    }

    public final void setJmeno(String noveJmeno) {
        this.jmeno = noveJmeno;
    }

    @Override
    public String toString() {
        // return "Jméno: " + getJmeno() + ", výška: " + getVyska();
        return String.format("Jméno: %s, výška: %d", getJmeno(), getVyska());
    }

    /* Již není doporučeno používat (od Javy v. 9)
    @Override
    protected void finalize() throws Throwable {
        super.finalize();
        System.out.format("Zvire %s je finalizováno%n", this.getJmeno());
    }
    */
}
